# -*- coding:utf-8 -*-
import os, ctypes, subprocess
from security_module import SecurityModule
from utils import create_file

from log import log_debug, log_error

RELABEL_FILE="/.exectl"

class ExectlModule(SecurityModule):
	status_desc = {
		"0": "关闭",
		"2": "启用(enabled)",
		"4": "启用(softmode)",
	}
	def __init__(self):
		SecurityModule.__init__(self, "exectl")

	@staticmethod
	def getstatus():
		try:
			kyseclib = ctypes.cdll.LoadLibrary("libkysec.so.0")
		except OSError as e:
			return 0
		else:
			return kyseclib.kysec_getstatus()

	@classmethod
	def do_enable(self):
		# result, error = create_file(RELABEL_FILE)
		try:
			kysec_scenelib = ctypes.cdll.LoadLibrary("libkysec_scene.so.0")
			kysec_scenelib.kysec_scene_set_module_status(0, 2)    # 执行控制
			kysec_scenelib.kysec_scene_set_module_status(1, 2)    # netctl
			kysec_scenelib.kysec_scene_set_module_status(2, 1)    # fpro
			kysec_scenelib.kysec_scene_set_module_status(3, 1)    # kmodctl
			kysec_scenelib.kysec_scene_set_module_status(5, 1)    # ppro
			kysec_scenelib.kysec_scene_set_module_status(6, 2)    # devctl
			kysec_scenelib.kysec_scene_set_module_status(10, 1)   # pblk
			kysec_scenelib.kysec_scene_set_module_status(11, 1)   # box
			kysec_scenelib.kysec_scene_set_module_status(13, 1)   # kid
			kysec_scenelib.kysec_scene_setstatus(2, 1) # 0 关闭 2 强制模式 4 软模式； 1 永久生效   2 临时生效
		except Exception as e:
			return (False, "libkysec_scene.so.0 打开失败")

		return (True, None)
		# if not result:
		# 	return (False, "无法创建标记文件 '%s'"%RELABEL_FILE)
		# else:
		# 	return (True, None)

	@classmethod
	def do_disable(self):
		try:
			# if os.path.exists(RELABEL_FILE):
			# 	os.unlink(RELABEL_FILE)
			#kysec_lib = ctypes.cdll.LoadLibrary("libkysec_extend.so.0")
			kysec_scenelib = ctypes.cdll.LoadLibrary("libkysec_scene.so.0")
			# kysec_lib.kysec_setstatus(4) # 0 关闭 2 强制模式 4 软模式； 1 永久生效   2 临时生效
			kysec_scenelib.kysec_scene_set_module_status(0, 0)    # exectl
			kysec_scenelib.kysec_scene_set_module_status(1, 0)    # netctl
			kysec_scenelib.kysec_scene_set_module_status(2, 0)    # fpro
			kysec_scenelib.kysec_scene_set_module_status(3, 0)    # kmodctl
			kysec_scenelib.kysec_scene_set_module_status(5, 0)    # ppro
			kysec_scenelib.kysec_scene_set_module_status(6, 0)    # devctl
			# kysec_scenelib.kysec_scene_set_module_status(11, 1)  # box  关闭时 不关闭box
			kysec_scenelib.kysec_scene_set_module_status(13, 0)  # kid
			kysec_scenelib.kysec_scene_setstatus(2, 1)
		except Exception as e:
			error = "libkysec_scene.so.0 打开失败"
			log_error("%s: %s"%(error, str(e)))
			return (False, error)
		return (True, None)

